package cliente;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;



public class ConectorCliente implements Runnable {

	//Variables para la comunicación:
	DataOutputStream flujoSalida;
	DataInputStream flujoEntrada;
	Socket socket;
	
	InterfazCliente interfaz;
	
	public ConectorCliente(InterfazCliente interfaz){
		this.interfaz = interfaz;
	}
	
	//Método para conectarse al servidor
	public boolean conectar(){
		String Host = "localhost";
		int Puerto = 8000;	

		//ABRIR SOCKET
		try {
			socket = new Socket(Host, Puerto);
		} catch (UnknownHostException e1) {e1.printStackTrace();return false;} 
		catch (IOException e1) {e1.printStackTrace();return false;}

		//Abrimos los flujos
		try {
			flujoSalida = new DataOutputStream(socket.getOutputStream());
			flujoEntrada = new DataInputStream(socket.getInputStream());
		} catch (IOException e2) {e2.printStackTrace();return false;}
				
		
		return true;
	}
	
	
	//Arrancamos un hilo que esté escuchando contínuamente al servidor.
	public void arrancarRecepcion(){
		Thread hiloReceptor = new Thread(this);
		hiloReceptor.start();
	}
	
	//Método para enviar mensajes al servidor.
	public void enviarMensaje(String mensaje){
		try {
			flujoSalida.writeUTF(mensaje);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	

	//Método run del hilo que va a estar checkeando mensajes de entrada contínuamente.
	@Override
	public void run() {
		String recepcion;

		while(true){
			try {
				recepcion = flujoEntrada.readUTF();
				interfaz.llegaMensaje(recepcion);
			} catch (IOException e) {
				break;
			}
		}
		
		//Fin de la comunicación:
		cerrar();
		interfaz.llegaMensaje("Fin de la comunicación con el servidor");
	}
	
	
	
	//Método para cerrar la comunicación.
	public void cerrar(){
		try {
			flujoEntrada.close();
			flujoSalida.close();
			socket.close();
			
		} catch (IOException e) {e.printStackTrace();}
	}
	
	

}
