package cliente;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class InterfazCliente extends JFrame {

	
	InterfazCliente interfaz = this;
	
	int ancho = 300;
	int alto = 300;
	
	//Variable para control de la conexión.
	ConectorCliente  conector;
	
	//Variables componentes de la interfaz:
	JTextField textoEnvio;
	JButton botonEnvio;
	JTextArea areaRecepcion;
	
	public InterfazCliente(){
			
		setBounds(200,200,ancho,alto);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		conector = new ConectorCliente(this);
		
		if (conector.conectar()){
			//Añadir componentes:
			anadirComponentes();
			
			//Añadir ActionListeners:
			anadirListeners();

			
			visualizar();
		}

	}
	
	
	public void anadirComponentes(){
		
		getContentPane().setLayout(new GridBagLayout());
		GridBagConstraints settings;
		
		//Para enviar mensajes:
		textoEnvio = new JTextField();
		textoEnvio.setEnabled(false);
		
		botonEnvio = new JButton("Enviar");
		botonEnvio.setEnabled(false);
		
		areaRecepcion = new JTextArea();
		areaRecepcion.setEditable(false);
		areaRecepcion.setWrapStyleWord(true);
		
		//Colocamos los elementos
		//Mensajes salida.
		settings = new GridBagConstraints();
		settings.gridx = 0;
		settings.gridy = 0;
		settings.weightx = 1;
		settings.ipady = 20;
		settings.fill = GridBagConstraints.BOTH;
		settings.insets = new Insets(5, 5, 2, 2);
		getContentPane().add(textoEnvio,settings);
		//Botón de envío.
		settings = new GridBagConstraints();
		settings.gridx = 1;
		settings.gridy = 0;
		settings.ipadx = 20;
		settings.ipady = 20;
		settings.fill = GridBagConstraints.BOTH;
		settings.insets = new Insets(5, 2, 2, 5);
		getContentPane().add(botonEnvio,settings);
		//El área de recibir mensajes.
		settings = new GridBagConstraints();
		settings.gridx = 0;
		settings.gridy = 1;
		settings.gridwidth = 2;
		settings.weightx = 1;
		settings.weighty = 1;
		settings.ipady = 20;
		settings.fill = GridBagConstraints.BOTH;
		settings.insets = new Insets(2, 5, 5, 5);
		getContentPane().add(new JScrollPane(areaRecepcion),settings);
		
		
		
		
	}
	
	public void anadirListeners(){
		botonEnvio.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				conector.enviarMensaje(textoEnvio.getText());
				textoEnvio.setText("");
			}
		});
	}
	
	
	public void visualizar(){
		setVisible(true);
		
		//Preguntar el nombre del usuario:
		String usuarioNombre = JOptionPane.showInputDialog(interfaz,"Introduce el nombre de usuario que vas a utilizar:");
		conector.enviarMensaje(usuarioNombre);
		
		textoEnvio.setEnabled(true);
		botonEnvio.setEnabled(true);
		
		//Arrancamos la escucha.
		conector.arrancarRecepcion();
		
		
	}
	
	
	public void llegaMensaje(String mensaje){
		areaRecepcion.setText(areaRecepcion.getText()+"\n"+mensaje);
	}
	
	
	public static void main(String[] args) {
		InterfazCliente interfaz = new InterfazCliente();
	}
}
