package servidor;

import java.io.DataInputStream;
import java.io.IOException;
import java.net.Socket;

public class HiloEscuchaHijo extends Thread{
	ManejadorBroadCast broadcast;
	DataInputStream flujoEntradaDeCliente;
	Socket socketCliente;
	
	public HiloEscuchaHijo() {
		// TODO Auto-generated constructor stub
	}
	
	public HiloEscuchaHijo(ManejadorBroadCast broadcast, Socket socketCliente) {
		this.broadcast = broadcast;
		this.socketCliente = socketCliente;
		try {
			flujoEntradaDeCliente = new DataInputStream(socketCliente.getInputStream());
		} catch (IOException e) {
			System.out.println("Error al crear el flujo de entrada del cliente");
			e.printStackTrace();
		}
		

	}
	
	//El método RUN. El primer mensaje que reciba será el nombre del cliente.
	//Cuando lo recibamos guardaremos ese flujo de salida asociado al nombre en "broadcast".
	//Seguiremos escuchando mensajes hasta que se cierre el flujo de entrada, en ese momento,
	//eliminamos el flujo de salida de "broadcast".
	@Override
	public void run() {
		String mensajeCliente;
		
		String nombreCliente = "NO NAME";
		try {
			nombreCliente = flujoEntradaDeCliente.readUTF();
			broadcast.anadirFlujoSalida(socketCliente,nombreCliente);
			System.out.println("Se conecta el usuario "+nombreCliente);
			broadcast.broadcast("<<SERVER>> "+nombreCliente+" entró en el chat.");
		} catch (IOException e) {
			System.out.println("Error al recibir el nombre del cliente.");
			e.printStackTrace();
		}
		
		while(true){ //Sacamos mensajes hasta que se corte la comunicación.
			try {
				mensajeCliente = flujoEntradaDeCliente.readUTF();
				System.out.println("El cliente "+ nombreCliente+" ha enviado: "+mensajeCliente);
				broadcast.broadcast("<<"+nombreCliente+">>"+mensajeCliente);
			} catch (IOException e) {
				broadcast.quitarFlujoSalida(nombreCliente);
				break;
			}
		}
		
		System.out.println("Fin de conexión del cliente + "+nombreCliente);
		broadcast.broadcast("<<SERVER>> "+nombreCliente+" abandonó el chat.");
		
		try {
			flujoEntradaDeCliente.close();
			socketCliente.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
}



