package servidor;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;

public class ManejadorBroadCast {

	ArrayList<DataOutputStream> flujosSalida;
	ArrayList<String> nombresClientes;
	
	public ManejadorBroadCast() {
		flujosSalida = new ArrayList<DataOutputStream>();
		nombresClientes = new ArrayList<String>();
	}
	
	//Método para añadir un nuevo flujo de salida al hacer broadcast.
	public synchronized void anadirFlujoSalida(Socket socketCliente, String nombre){
		DataOutputStream flujoSalidaACliente = null;
		try {
			flujoSalidaACliente = new DataOutputStream(socketCliente.getOutputStream());
		} catch (IOException e) {
			System.out.println("Error al crear el flujo de salida de un cliente");
			e.printStackTrace();
		}
		flujosSalida.add(flujoSalidaACliente);
		nombresClientes.add(nombre);
	}
	
	//Método para eliminar un flujo de salida asociado a una persona.
	public synchronized void quitarFlujoSalida(String nombre){
		int indiceBorrar = nombresClientes.indexOf(nombre);
		nombresClientes.remove(indiceBorrar);
		flujosSalida.remove(indiceBorrar);
	}
	
	//Método para enviar un mensaje de broadcast a todos los conectados en el chat.
	public synchronized void broadcast(String mensaje){
		for (int i = 0; i < flujosSalida.size(); i++) {
			try {
				flujosSalida.get(i).writeUTF(mensaje);
			} catch (IOException e) {
				System.out.println("Error al escribir en el flujo de salida. (Broadcast).");
				e.printStackTrace();
			}
		}
	}
	
}

